%module flwt

%{
/* System header files */
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "constant.h"
#include "flwtdef.h"
#include "flwterr.h"
#include "filter.h"
#include "flwt.h"
#include "imgmem.h"
#include "lift.h"
#include "mallat.h"
#include "mem.h"
#include "util.h"
#include "arrayobject.h"
%}

/* Static Global Variables */
static Vector filter;      /* Vector with filter coefficients */
static Matrix liftingX;    /* Matrix with lifting coefficients in X */
static Matrix liftingY;    /* Matrix with lifting coefficients in Y */

typedef          Vector *    Matrix;
typedef          Matrix *    Volume;
typedef short    int         boolean;

/*
%typemap(python,arginit) Vector ARRAY1D (npy_intp na[10]) {
    import_array();
    na[0] = 0;
}

%typemap(python,in) Vector ARRAY1D {
   PyArrayObject *array;
   PyArrayObject *o;
   PyArrayObject *a;
   na[0] += 1;
   o = (PyArrayObject *) $source;
   a = (PyArrayObject *)
       PyArray_ContiguousFromObject( $source, o->descr->type, 0, 0);
   array= (PyArrayObject *) PyArray_Cast( a, 'd');
   $target = (Vector ) ( array->data);
   na[na[0]] = (npy_intp ) array;
   Py_DECREF(a);
}

%typemap(python,argout) Vector ARRAY1D {
   int j;
   PyArrayObject *a;
   if (na[0] > 0) {
     for (j=1;j<=na[0];j++) {
       a = (PyArrayObject *) na[j];
       Py_DECREF(a);
     }
   }
   na[0] = 0;
}
*/


%typemap(python,arginit) Matrix ARRAY2D (char **Mptr) {
    import_array();
}

%typemap(python,in) Matrix ARRAY2D {
   PyObject *o;
   int temp,mm,mn;
   o = (PyObject *) $source;
   temp = PyArray_As2D( &o, &Mptr, &mm, &mn, PyArray_DOUBLE);
   $target = (Matrix) Mptr;
}

%typemap(python,argout) Matrix ARRAY2D {
   PyObject *o;
   o = (PyObject *) _obj0;
   PyArray_Free(o,Mptr);
}


/*

%typemap(python,arginit) Vector ARRAY1D (npy_intp na[10]) {
    import_array();
    na[0] = 0;
}

%typemap(python,in) Vector ARRAY1D {
//   PyArrayObject *array;
   PyObject *o;
//   PyArrayObject *a;
   char * Vptr;
   int mm;
   int temp;
   na[0] += 1;
   o = (PyObject *) $source;
//   temp = PyArray_As1D( &o, &Vptr, &mm, PyArray_DOUBLE);
   temp = PyArray_AsCArray( &o, &Vptr, &mm, PyArray_DOUBLE);
   $target = (Vector) Vptr;
}

*/

//%inline %{
//#include "constant.h"
//#include "flwtdef.h"
//#include "filter.h"
//#include "imgmem.h"
//#include "lift.h"
//#include "mem.h"
//#include "util.h"
//%}

/* Direct/Inverse 2D Fast Lifted Wavelet Transform */
extern void
FLWT2D ( Matrix ARRAY2D, const int __cols, const int __rows, const int __N,
                        const int __nTilde, const int __levels,
                        const boolean __inverse );

extern void FLWTChangeFormat ( Matrix ARRAY2D, 
                               const int __width, const int __height,
                               const int __N, const int __nTilde,
                               const int __levels, const boolean __inverse );

extern void
GetDual ( const int __cols, const int __rows, const int __N, const int __nTilde,
          const boolean __print_coeff, const int __levels );

extern void
GetReal ( const int __cols, const int __rows, const int __N, const int __nTilde,
          const boolean __print_coeffs, const int __levels );


