/*
 *  -*- Mode: ANSI C -*-
 *  $Id: flwtapi.h,v 1.3 1996/08/16 17:23:22 fernande Exp $
 *  $Source: /sgi.acct/sweldens/cvs/liftpack/include/flwtapi.h,v $
 *  Author: Fernandez, Gabriel
 *
 *  Defines the data structure used to store the options needed
 *  by the wavelet transform functions.
 */
/* do not edit anything above this line */

#ifndef __FLWTAPI_H__
#define __FLWTAPI_H__

#include "flwtdef.h"
#include "flwtfilt.h"

typedef enum {
    FORWARD,       /* apply Forward transform */
    INVERSE,       /* apply Inverse transform */
    FILTER,        /* apply filter (Forward & Inverse) */
    WAVELET        /* calculate Wavelet function (Inverse only) */
} FLWTMode;

typedef struct {
    char infile[MAX_FILENAME],   /* input data file */
         outfile[MAX_FILENAME],  /* output data file */
         frmType[MAX_FILETYPE];  /* output file type */
    int sizeY,                   /* height of image */
        sizeX,                   /* width of image */
        N,                       /* number of filter coefficients */
        nTilde,                  /* number of lifting coefficients */
        gamma,                   /* value for gamma correction */
        levels,                  /* maximum level for the transform */
        x, y;                    /* position of point in the "point image" */
    Beta beta;                   /* beta structure for filtering operations */
    FLWTMode mode;               /* type of operation to be done */
    boolean print,               /* whether to print the coefficients */
            scale,               /* whether to scale the results */
	    mallat,              /* whether to save the file in Mallat format */ 
            packets;             /* whether to calculate wavelet packets */
} ParamStruct;

/* Fast Lifted Wavelet Transform Application Interface Program */
extern void FLWTAPI ( ParamStruct __param );

#endif /* __FLWTAPI_H__ */
