/*
 *  -*- Mode: ANSI C -*-
 *  $Id: flwterr.h,v 1.1 1996/09/17 16:11:02 fernande Exp $
 *  $Source: /sgi.acct/sweldens/cvs/liftpack/include/flwterr.h,v $
 *  Author: Gabriel Fernandez
 *
 *  Declares the functions used when an error has been captured.
 */
/* do not edit anything above this line */

#ifndef __FLWTERROR_H__
#define __FLWTERROR_H__

#include <stdarg.h>

/* Return type */
typedef enum {
	RETURN,
	ABORT
} RetType;

/* Enumeration of all error codes used in the program */
typedef enum {
	/* General Errors */
	MISSING_PARAMETER,
	INVALID_ANSWER,
	INVALID_RELATIONAL_INT,
	INVALID_RELATIONAL_FLT,
	INVALID_VALUE_INT,
	INVALID_VALUE_FLT,
	NOT_EVEN,
	IGNORE,
	DENOM_NEAR_ZERO,
	SINGULAR_MATRIX,
	NO_LIFTING_MATRIX,
	NO_FILTER_VECTOR,
	FATAL_ERROR,
	/* Memory Errors */
	MALLOC_FAIL,
	CALLOC_FAIL,
	REALLOC_FAIL,
	MEMORY_VECTOR,
	MEMORY_MATRIX,
	MEMORY_IMAGE,
	/* File Errors */
	NO_FILE,
	NO_DIR,
	READ_ERROR,
	WRITE_ERROR,
	INVALID_FILE_FORMAT,
	NO_READABLE_FORMAT,
	NO_FORMAT,
	/* Custom Error */
        CUSTOM
} ErrorCode;

/* Error handling function */
extern void Error ( const char *_functionName, const ErrorCode _errCode,
                    const RetType _returnType, ... );

#endif /* __FLWTERROR_H__ */
