/*
 *  -*- Mode: ANSI C -*-
 *  $Id: lu.h,v 1.2 1996/08/16 17:23:27 fernande Exp $
 *  $Source: /sgi.acct/sweldens/cvs/liftpack/include/lu.h,v $
 *  Author: Fernandez, Gabriel
 *
 *  Declaration of the functions used to perform the LU decomposition
 *  of matrix a. Function LUdcmp() performs the LU operations on a[][]
 *  and function LUbksb() performs the backsubstitution giving the
 *  solution in b[];
 */
/* do not edit anything above this line */

#ifndef __LU_H__
#define __LU_H__

#include "flwtdef.h"

/* LU decomposition */
extern void LUdcmp ( Matrix __a, int __n, int *__indx, Flt *__d );

/* LU backsubstitution */
extern void LUbksb ( Matrix __a, int __n, int *__indx, Vector __b );

#endif /* __LU_H__ */
